using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace SampleApplication {
    public partial class Form1 : Form {
        public Form1() {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e) {
            // Read list of serial ports
            string[] portNames = System.IO.Ports.SerialPort.GetPortNames();
            if (portNames.Length == 0) {
                // No serial ports present
                this.groupBoxSerial.Enabled = false;
                this.groupBoxUsb.Enabled = false;
            }
            else {
                // Fill serial port combos
                this.comboBoxSerialPort.Items.AddRange(portNames);
                this.comboBoxUsbPort.Items.AddRange(portNames);
                this.comboBoxSerialPort.SelectedIndex = 0;
                this.comboBoxUsbPort.SelectedIndex = portNames.Length - 1;
            }
        }

        private void ShowTemperature(Papouch.Thermometers.ISensor sensor) {
            float t = sensor.ReadSample();
            MessageBox.Show(string.Format("Current temperature is {0:N1} C", t), "Sample application", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void buttonReadSerial_Click(object sender, EventArgs e) {
            ShowTemperature(new Papouch.Thermometers.SerialSensor((string)this.comboBoxSerialPort.SelectedItem));
        }

        private void buttonReadUsb_Click(object sender, EventArgs e) {
            ShowTemperature(new Papouch.Thermometers.UsbSensor((string)this.comboBoxUsbPort.SelectedItem));
        }

        private void buttonReadHttp_Click(object sender, EventArgs e) {
            ShowTemperature(new Papouch.Thermometers.HttpSensor(this.textBoxHttpUrl.Text));
        }

        private void buttonReadTcp_Click(object sender, EventArgs e) {
            ShowTemperature(new Papouch.Thermometers.TcpSensor(this.textBoxTcpHost.Text, (int)this.numericUpDownTcpPort.Value));
        }
    }
}